package dns_protocol_crawler_go

import (
	"encoding/json"
	"loafle.com/overflow/commons_go/matcher/dns"
	"loafle.com/overflow/crawler_go"
)

type DNSHealthCrawler struct {
	crawler.SocketHeahthCrawler
}

func (r *DNSHealthCrawler)Internal(params map[string]interface{}) ([]byte, error) {
	
	b, err := r.CheckHeahth(params)
	if err != nil {
		// set error
	}
	return json.Marshal(b)
}

func NewDNSHealthCrawler() *DNSHealthCrawler {
	r := &DNSHealthCrawler{}
	r.SetInternal(r)
	r.SetMatcher(dns.NewDnsMatcher())
	return r
}
